## xen 4.8.5

=== debian/changelog ===
xen (2001:4.8.5-29+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sun, 03 Jan 2021 07:09:25 +0100

xen (2001:4.8.5-29) unstable; urgency=medium

  * Fix patch-xen-gcc10-fixes.patch context, apply recent patches to deb
    too
  * Add .gitlab-ci.yml
  * debian: update compat version to 10
  * archlinux: use autoreconf --install
  * gitlab-ci: use separate exclude install list for dom0 and vm
  * Cleanup parent xenstore dir after device remove

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 03 Jan 2021 07:09:25 +0100

xen (2001:4.8.5-28) unstable; urgency=medium

  * Backport a set of xenstore fixes
  * Apply XSA-115 and XSA-325 patches

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 15 Dec 2020 13:11:42 +0100

xen (2001:4.8.5-27) unstable; urgency=medium

  * Apply XSA-355 patch

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 24 Nov 2020 13:08:11 +0100

xen (2001:4.8.5-26) unstable; urgency=medium

  * Apply XSA-351 patches

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 11 Nov 2020 04:15:55 +0100

xen (2001:4.8.5-25) unstable; urgency=medium

  * Apply XSA-345, XSA-346, XSA-347

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 20 Oct 2020 01:37:59 +0200

xen (2001:4.8.5-24) unstable; urgency=medium

  * debian: force python2
  * travis: update
  * rpm: add missing epoch to xen-qemu-tools dependency

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 18 Oct 2020 06:22:59 +0200

xen (2001:4.8.5-23) wheezy; urgency=medium

  * Apply XSA-337, XSA-340, XSA-343

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 22 Sep 2020 02:56:19 +0200

xen (2001:4.8.5-22) unstable; urgency=medium

  * Fix startup PVH domain with xl
  * Include GCC 10 build fixes in debian and arch too

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 15 Aug 2020 23:48:43 +0200

xen (2001:4.8.5-21) unstable; urgency=medium

  * Backport xenstored fix

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 10 Aug 2020 11:12:47 +0200

xen (2001:4.8.5-20) unstable; urgency=medium

  [ M. Vefa Bicakci ]
  * Park unused CPU threads after suspend-to-RAM

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 08 Aug 2020 14:41:09 +0200

xen (2001:4.8.5-19) unstable; urgency=medium

  * Apply XSA-321 and its dependencies

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 07 Jul 2020 14:50:46 +0200

xen (2001:4.8.5-18) unstable; urgency=medium

  * Apply TSX related fixes for Haswell/Broadwell CPUs

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 28 May 2020 16:17:47 +0200

xen (2001:4.8.5-17) unstable; urgency=medium

  [ M. Vefa Bicakci ]
  * libxl: Enable debug_symbols
  * libxl: Resolve device disconnection bugs

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 09 May 2020 03:43:00 +0200

xen (2001:4.8.5-16) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Add gcc-10 fixes and disable vtm build for stubdom
  * Fix gcc-10: remove -Wno-error=format-truncation

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 22 Apr 2020 05:54:24 +0200

xen (2001:4.8.5-15) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Disable commonly broken EFI GetTime() call
  * Support also allow_interrupt_control sysfs entry, in addition to
    allow_msi_enable

  [ Paweł Marczewski ]
  * libxl: wait for console path before firing console_available
  * libxl: fix cleanup bug in initiate_domain_create()

  [ Frédéric Pierret (fepitre) ]
  * Currently disable building EFI for CentOS 7

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 09 Apr 2020 03:10:48 +0200

xen (2001:4.8.5-14) unstable; urgency=medium

  * Apply XSA-310, XSA-311

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 11 Dec 2019 13:23:37 +0100

xen (2001:4.8.5-13) unstable; urgency=medium

  * travis: switch to bionic, drop jessie build
  * Apply XSA-306 fix

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 26 Nov 2019 15:13:03 +0100

xen (2001:4.8.5-12) wheezy; urgency=medium

  * Apply XSA-293 as a contextual dependency for XSA-305
  * Apply XSA-305 patches

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 13 Nov 2019 15:34:23 +0100

xen (2001:4.8.5-11) unstable; urgency=medium

  * Apply XSA-299, XSA-302, and XSA-290, XSA-291 as prerequisites

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 31 Oct 2019 13:02:42 +0100

xen (2001:4.8.5-10) wheezy; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * spec: remove old constraint and fix qemu-img provided by xen
  * spec: disable blktap2
  * spec: don't fail on missing build-ids
  * travis: add Fedora 31

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 11 Sep 2019 21:35:02 +0200

xen (2001:4.8.5-9) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * travis: add bullseye and drop old Fedoras

  [ Frédéric Pierret (fepitre) ]
  * spec: drop systemd_postun

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 08 Sep 2019 16:29:59 +0200

xen (2001:4.8.5-8) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Fix -Wsign-compare warning

  [ Yukikoo ]
  * Add GCC patch to fix archlinux template building

  [ Ivan Kardykov ]
  * add patch from OpenXT to additional support in ACPI builder to apply
    SLIC and OEM installs

  [ Frédéric Pierret (fepitre) ]
  * Fix build for bullseye

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 07 Sep 2019 13:43:45 +0200

xen (2001:4.8.5-7) unstable; urgency=medium

  * Apply fixes for framebuffer placed over 4GB

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 28 Jun 2019 15:02:44 +0200

xen (2001:4.8.5-6) unstable; urgency=medium



=== debian/control ===
Source: xen
Section: kernel
Priority: optional
Maintainer: Jason Mehring <nrgaway@gmail.com>
Build-Depends: 
    autotools-dev,
    bcc,
    cmake,
    comerr-dev,
    debhelper (>= 9), 
    dh-autoreconf,
    dh-python,
    e2fslibs-dev,
    file,
    iasl,
    libaio-dev, 
    libaio1:amd64,
    libc6-i386,
    libfdt-dev,
    libglib2.0-dev,
    liblzma-dev:amd64,
    libmagic1:amd64,
    libsystemd-dev,
    libsystemd-dev:amd64,
    libncurses5-dev:amd64,
    libpixman-1-dev,
    libpython2.7:amd64,
    libpython2.7-dev,
    libssl-dev, 
    libssl-dev:amd64,
    libyajl-dev,
    libyajl-dev:amd64,
    mawk,
    mime-support,
    perl,
    pkg-config,
    python-dev | python2-dev,
    python | python2,
    seabios,
    uuid-dev:amd64,
    zlib1g-dev,
X-Python-Version: 2.7
Standards-Version: 3.9.5
Homepage: http://www.qubes-os.org
Vcs-Git: git://git.qubes-os.org/marmarek/vmm-xen-debian.git

Package: libxen-4.8
Section: libs
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libxen-lowlevel1.0 (<< 2001:4.8.4-4)
Breaks: libxen-lowlevel1.0 (<< 2001:4.8.4-4)
Pre-Depends: ${misc:Pre-Depends}
Description: Libraries for Xen tools
 This package contains the libraries providing an access to Xen hypervisor:
  - hypercalls
  - mapping foreign domain memory
  - accessing the grant table devices
  - accessing the evtchn device

Package: libxenstore3.0
Section: libs
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Xenstore communications library for Xen
 This package contains the client library interface to XenStore.

Package: libxen-dev
Section: libdevel
Architecture: amd64
Depends:
 libxen-4.8 (= ${binary:Version}),
 libxenstore3.0 (= ${binary:Version}),
 ${misc:Depends}
Description: Development libraries for Xen tools
 This package contains what's needed to develop applications
 which manage Xen virtual machines.

Package: xenstore-utils
Architecture: amd64
Section: admin
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: xen-utils-common (<= 3.1.0-1)
Conflicts: xen-utils-common (<= 3.1.0-1)
Description: Xenstore command line utilities for Xen
 This package contains command line utilities for interacting with
 XenStore.
 .
 XenStore is a shared database used for interdomain communication of
 configuration and status information.  It is accessible to all domains
 running on the same Xen host.  See http://wiki.xen.org/wiki/XenStore for
 more information.
 .
 In the common case these tools are used by the Xen toolstack running in
 domain0 (or a driver domain) however they may also be used in a guest
 domain to support local scripting which wants to communicate via XenStore.

Package: xen-utils-common
Architecture: all
Depends: lsb-base, python2 | python, udev, xenstore-utils, ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}
X-Python-Version: ${python:Versions}
Description: Xen administrative tools - common files
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DESTDIR=$(shell pwd)/debian/tmp
BUILD_DIR = debian/build

%:
	dh $@ --with autoreconf,autotools-dev,python2,systemd

override_dh_auto_configure:
	PYTHON=/usr/bin/python2 \
	dh_auto_configure -- --prefix=/usr \
		--includedir=/usr/include \
		--mandir=/usr/share/man \
		--infodir=/usr/share/info \
		--with-initddir=/etc/init.d \
		--enable-systemd \
		--with-linux-backend-modules="xen-evtchn xen-gntdev xen-gntalloc xen-blkback xen-privcmd xen-netback" \
		--with-systemd=/lib/systemd/system \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--disable-ocamltools \
		--disable-blktap2

override_dh_auto_build:
	dh_clean --keep
	make debug_symbols=y dist-tools

override_dh_auto_install:
	make DESTDIR=$(DESTDIR) install-tools
	(cd debian/tmp; rm -r `grep ^[a-z] ../not-installed`)
	dh_testdir
	dh_testroot
	dh_install --arch --sourcedir=debian/tmp --fail-missing
	dh_strip --arch
	dh_makeshlibs -V
	dh_shlibdeps
	dh_installchangelogs -XChangelog
	#dh_installdirs
	#dh_installdocs
	#dh_installexamples
	#dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- $(GENCONTROL_ARGS)
	#dh_gencontrol
	dh_md5sums
	dh_builddeb

## xen 4.8.5%2Bshim4.10.2%2Bxsa282

=== xen/Makefile ===
# This is the correct place to edit the build version.
# All other places this is stored (eg. compile.h) should be autogenerated.
export XEN_VERSION       = 4
export XEN_SUBVERSION    = 10
export XEN_EXTRAVERSION ?= .3-pre$(XEN_VENDORVERSION)
export XEN_FULLVERSION   = $(XEN_VERSION).$(XEN_SUBVERSION)$(XEN_EXTRAVERSION)
-include xen-version

export XEN_WHOAMI	?= $(USER)
export XEN_DOMAIN	?= $(shell ([ -x /bin/dnsdomainname ] && /bin/dnsdomainname) || ([ -x /bin/domainname ] && /bin/domainname || echo [unknown]))
export XEN_BUILD_DATE	?= $(shell LC_ALL=C date)
export XEN_BUILD_TIME	?= $(shell LC_ALL=C date +%T)
export XEN_BUILD_HOST	?= $(shell hostname)
export XEN_CONFIG_EXPERT ?= n

export BASEDIR := $(CURDIR)
export XEN_ROOT := $(BASEDIR)/..

# Do not use make's built-in rules and variables
MAKEFLAGS += -rR

EFI_MOUNTPOINT ?= $(BOOT_DIR)/efi

ARCH=$(XEN_TARGET_ARCH)
SRCARCH=$(shell echo $(ARCH) | sed -e 's/x86.*/x86/' -e s'/arm\(32\|64\)/arm/g')

# Don't break if the build process wasn't called from the top level
# we need XEN_TARGET_ARCH to generate the proper config
include $(XEN_ROOT)/Config.mk

# Allow someone to change their config file
export KCONFIG_CONFIG ?= .config

.PHONY: default
default: build

.PHONY: dist
dist: install

build install:: include/config/auto.conf

.PHONY: build install uninstall clean distclean cscope TAGS tags MAP gtags tests
build install uninstall debug clean distclean cscope TAGS tags MAP gtags tests::
ifneq ($(XEN_TARGET_ARCH),x86_32)
	$(MAKE) -f Rules.mk _$@
else
	echo "*** Xen x86/32 target no longer supported!"
endif

.PHONY: _build
_build: $(TARGET)$(CONFIG_XEN_INSTALL_SUFFIX)

.PHONY: _install
_install: D=$(DESTDIR)
_install: T=$(notdir $(TARGET))
_install: Z=$(CONFIG_XEN_INSTALL_SUFFIX)
_install: $(TARGET)$(CONFIG_XEN_INSTALL_SUFFIX)
	[ -d $(D)$(BOOT_DIR) ] || $(INSTALL_DIR) $(D)$(BOOT_DIR)
	$(INSTALL_DATA) $(TARGET)$(Z) $(D)$(BOOT_DIR)/$(T)-$(XEN_FULLVERSION)$(Z)
	ln -f -s $(T)-$(XEN_FULLVERSION)$(Z) $(D)$(BOOT_DIR)/$(T)-$(XEN_VERSION).$(XEN_SUBVERSION)$(Z)
	ln -f -s $(T)-$(XEN_FULLVERSION)$(Z) $(D)$(BOOT_DIR)/$(T)-$(XEN_VERSION)$(Z)
	ln -f -s $(T)-$(XEN_FULLVERSION)$(Z) $(D)$(BOOT_DIR)/$(T)$(Z)
	[ -d "$(D)$(DEBUG_DIR)" ] || $(INSTALL_DIR) $(D)$(DEBUG_DIR)
	$(INSTALL_DATA) $(TARGET)-syms $(D)$(DEBUG_DIR)/$(T)-syms-$(XEN_FULLVERSION)
	$(INSTALL_DATA) $(TARGET)-syms.map $(D)$(DEBUG_DIR)/$(T)-syms-$(XEN_FULLVERSION).map
	$(INSTALL_DATA) $(KCONFIG_CONFIG) $(D)$(BOOT_DIR)/$(T)-$(XEN_FULLVERSION).config
	if [ -r $(TARGET).efi -a -n '$(EFI_DIR)' ]; then \
		[ -d $(D)$(EFI_DIR) ] || $(INSTALL_DIR) $(D)$(EFI_DIR); \
		$(INSTALL_DATA) $(TARGET).efi $(D)$(EFI_DIR)/$(T)-$(XEN_FULLVERSION).efi; \
		if [ -e $(TARGET).efi.map ]; then \
			$(INSTALL_DATA) $(TARGET).efi.map $(D)$(DEBUG_DIR)/$(T)-$(XEN_FULLVERSION).efi.map; \
		fi; \
		ln -sf $(T)-$(XEN_FULLVERSION).efi $(D)$(EFI_DIR)/$(T)-$(XEN_VERSION).$(XEN_SUBVERSION).efi; \
		ln -sf $(T)-$(XEN_FULLVERSION).efi $(D)$(EFI_DIR)/$(T)-$(XEN_VERSION).efi; \
		ln -sf $(T)-$(XEN_FULLVERSION).efi $(D)$(EFI_DIR)/$(T).efi; \
		if [ -n '$(EFI_MOUNTPOINT)' -a -n '$(EFI_VENDOR)' ]; then \
			$(INSTALL_DATA) $(TARGET).efi $(D)$(EFI_MOUNTPOINT)/efi/$(EFI_VENDOR)/$(T)-$(XEN_FULLVERSION).efi; \
		elif [ "$(D)" = "$(patsubst $(shell cd $(XEN_ROOT) && pwd)/%,%,$(D))" ]; then \
			echo 'EFI installation only partially done (EFI_VENDOR not set)' >&2; \
		fi; \
	fi

.PHONY: _tests
_tests:
	$(MAKE) -f $(BASEDIR)/Rules.mk -C test tests

.PHONY: _uninstall
_uninstall: D=$(DESTDIR)
_uninstall: T=$(notdir $(TARGET))
_uninstall: Z=$(CONFIG_XEN_INSTALL_SUFFIX)
_uninstall:
	rm -f $(D)$(BOOT_DIR)/$(T)-$(XEN_FULLVERSION).config
	rm -f $(D)$(BOOT_DIR)/$(T)-$(XEN_FULLVERSION)$(Z)
	rm -f $(D)$(BOOT_DIR)/$(T)-$(XEN_VERSION).$(XEN_SUBVERSION)$(Z)
	rm -f $(D)$(BOOT_DIR)/$(T)-$(XEN_VERSION)$(Z)
	rm -f $(D)$(BOOT_DIR)/$(T)$(Z)
	rm -f $(D)$(DEBUG_DIR)/$(T)-syms-$(XEN_FULLVERSION)
	rm -f $(D)$(DEBUG_DIR)/$(T)-syms-$(XEN_FULLVERSION).map
	rm -f $(D)$(EFI_DIR)/$(T)-$(XEN_FULLVERSION).efi
	rm -f $(D)$(EFI_DIR)/$(T)-$(XEN_VERSION).$(XEN_SUBVERSION).efi
	rm -f $(D)$(DEBUG_DIR)/$(T)-$(XEN_FULLVERSION).efi.map
	rm -f $(D)$(EFI_DIR)/$(T)-$(XEN_VERSION).efi
	rm -f $(D)$(EFI_DIR)/$(T).efi
	rm -f $(D)$(EFI_MOUNTPOINT)/efi/$(EFI_VENDOR)/$(T)-$(XEN_FULLVERSION).efi

.PHONY: _debug
_debug:
	$(OBJDUMP) -D -S $(TARGET)-syms > $(TARGET).s

.PHONY: _clean
_clean: delete-unfresh-files
	$(MAKE) -C tools clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C include clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C common clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C drivers clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C xsm clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C crypto clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C arch/arm clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C arch/x86 clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C test clean
	$(MAKE) -f $(BASEDIR)/tools/kconfig/Makefile.kconfig ARCH=$(ARCH) SRCARCH=$(SRCARCH) clean
	find . \( -name "*.o" -o -name ".*.d" -o -name "*.gcno" \) -exec rm -f {} \;
	rm -f include/asm $(TARGET) $(TARGET).gz $(TARGET).efi $(TARGET).efi.map $(TARGET)-syms $(TARGET)-syms.map *~ core
	rm -f include/asm-*/asm-offsets.h
	rm -f .banner

.PHONY: _distclean
_distclean: clean
	rm -f tags TAGS cscope.files cscope.in.out cscope.out cscope.po.out GTAGS GPATH GRTAGS GSYMS .config

$(TARGET).gz: $(TARGET)
	gzip -n -f -9 < $< > $@.new
	mv $@.new $@

$(TARGET): delete-unfresh-files
	$(MAKE) -C tools
	$(MAKE) -f $(BASEDIR)/Rules.mk include/xen/compile.h
	[ -e include/asm ] || ln -sf asm-$(TARGET_ARCH) include/asm
	[ -e arch/$(TARGET_ARCH)/efi ] && for f in boot.c runtime.c compat.c efi.h;\
		do ln -nsf ../../../common/efi/$$f arch/$(TARGET_ARCH)/efi/; done;\
		true
	$(MAKE) -f $(BASEDIR)/Rules.mk -C include
	$(MAKE) -f $(BASEDIR)/Rules.mk -C arch/$(TARGET_ARCH) asm-offsets.s
	$(MAKE) -f $(BASEDIR)/Rules.mk include/asm-$(TARGET_ARCH)/asm-offsets.h
	$(MAKE) -f $(BASEDIR)/Rules.mk -C arch/$(TARGET_ARCH) $@

# drivers/char/console.o contains static banner/compile info. Blow it away.
# Don't refresh these files during e.g., 'sudo make install'
.PHONY: delete-unfresh-files
delete-unfresh-files:
	@if [ ! -r include/xen/compile.h -o -O include/xen/compile.h ]; then \
		rm -f include/xen/compile.h; \
	fi

.banner: Makefile
	@if which figlet >/dev/null 2>&1 ; then \
		echo " Xen $(XEN_FULLVERSION)" | figlet -f tools/xen.flf > $@.tmp; \
	else \
		echo " Xen $(XEN_FULLVERSION)" > $@.tmp; \
	fi
	@mv -f $@.tmp $@

# compile.h contains dynamic build info. Rebuilt on every 'make' invocation.
include/xen/compile.h: include/xen/compile.h.in .banner
	@sed -e 's/@@date@@/$(XEN_BUILD_DATE)/g' \
	    -e 's/@@time@@/$(XEN_BUILD_TIME)/g' \
	    -e 's/@@whoami@@/$(XEN_WHOAMI)/g' \
	    -e 's/@@domain@@/$(XEN_DOMAIN)/g' \
	    -e 's/@@hostname@@/$(XEN_BUILD_HOST)/g' \
	    -e 's!@@compiler@@!$(shell $(CC) $(CFLAGS) --version 2>&1 | head -1)!g' \
	    -e 's/@@version@@/$(XEN_VERSION)/g' \
	    -e 's/@@subversion@@/$(XEN_SUBVERSION)/g' \
	    -e 's/@@extraversion@@/$(XEN_EXTRAVERSION)/g' \
	    -e 's!@@changeset@@!$(shell tools/scmversion $(XEN_ROOT) || echo "unavailable")!g' \
	    < include/xen/compile.h.in > $@.new
	@cat .banner
	@$(PYTHON) tools/fig-to-oct.py < .banner >> $@.new
	@mv -f $@.new $@

include/asm-$(TARGET_ARCH)/asm-offsets.h: arch/$(TARGET_ARCH)/asm-offsets.s
	@(set -e; \
	  echo "/*"; \
	  echo " * DO NOT MODIFY."; \
	  echo " *"; \
	  echo " * This file was auto-generated from $<"; \
	  echo " *"; \
	  echo " */"; \
	  echo ""; \
	  echo "#ifndef __ASM_OFFSETS_H__"; \
	  echo "#define __ASM_OFFSETS_H__"; \
	  echo ""; \
	  sed -rne "/==>/{s:.*==>(.*)<==.*:\1:; s: [\$$#]: :; p;}"; \
	  echo ""; \
	  echo "#endif") <$< >$@

SUBDIRS = xsm arch/$(TARGET_ARCH) common drivers test
define all_sources
    ( find include/asm-$(TARGET_ARCH) -name '*.h' -print; \
      find include -name 'asm-*' -prune -o -name '*.h' -print; \
      find $(SUBDIRS) -name '*.[chS]' -print )
endef

define set_exuberant_flags
    exuberant_flags=`$1 --version 2>/dev/null | (grep -iq exuberant && \
	echo "-I __initdata,__exitdata,__acquires,__releases \
	    -I EXPORT_SYMBOL \
	    --extra=+f --c-kinds=+px") || true` 
endef

.PHONY: xenversion
xenversion:
	@echo $(XEN_FULLVERSION)

.PHONY: _TAGS
_TAGS: 
	set -e; rm -f TAGS; \
	$(call set_exuberant_flags,etags); \
	$(all_sources) | xargs etags $$exuberant_flags -a

.PHONY: _tags
_tags: 
	set -e; rm -f tags; \
	$(call set_exuberant_flags,ctags); \
	$(all_sources) | xargs ctags $$exuberant_flags -a

.PHONY: _gtags
_gtags:
	set -e; rm -f GTAGS GSYMS GPATH GRTAGS
	$(all_sources) | gtags -f -

.PHONY: _cscope
_cscope:
	$(all_sources) > cscope.files
	cscope -k -b -q

.PHONY: _MAP
_MAP:
	$(NM) -n $(TARGET)-syms | grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' > System.map

.PHONY: FORCE
FORCE:

%.o %.i %.s: %.c FORCE
	$(MAKE) -f $(BASEDIR)/Rules.mk -C $(*D) $(@F)

%.o %.s: %.S FORCE
	$(MAKE) -f $(BASEDIR)/Rules.mk -C $(*D) $(@F)

%/: FORCE
	$(MAKE) -f $(BASEDIR)/Rules.mk -C $* built_in.o built_in_bin.o

kconfig := silentoldconfig oldconfig config menuconfig defconfig \
	nconfig xconfig gconfig savedefconfig listnewconfig olddefconfig \
	randconfig
.PHONY: $(kconfig)
$(kconfig):
	$(MAKE) -f $(BASEDIR)/tools/kconfig/Makefile.kconfig ARCH=$(ARCH) SRCARCH=$(SRCARCH) HOSTCC="$(HOSTCC)" HOSTCXX="$(HOSTCXX)" $@

include/config/%.conf: include/config/auto.conf.cmd $(KCONFIG_CONFIG)
	$(MAKE) -f $(BASEDIR)/tools/kconfig/Makefile.kconfig ARCH=$(ARCH) SRCARCH=$(SRCARCH) HOSTCC="$(HOSTCC)" HOSTCXX="$(HOSTCXX)" silentoldconfig

# Allow people to just run `make` as before and not force them to configure
$(KCONFIG_CONFIG):
	$(MAKE) -f $(BASEDIR)/tools/kconfig/Makefile.kconfig ARCH=$(ARCH) SRCARCH=$(SRCARCH) HOSTCC="$(HOSTCC)" HOSTCXX="$(HOSTCXX)" defconfig

# Break the dependency chain for the first run
include/config/auto.conf.cmd: ;

-include $(BASEDIR)/include/config/auto.conf.cmd

=== debian/changelog ===
xen (4.8.5+shim4.10.2+xsa282-1+deb9u11) stretch-security; urgency=medium

  * Update to new upstream versions:
     * Main tree updated to Xen 4.8.5
     * Shim updated to current upstream stable-4.10 branch, to
       avoid errors trying to cherry-pick security patches.
  * This includes fixes to:
       XSA-282 	CVE-2018-19967                 Xen 4.8 and 4.10 shim
       XSA-280 	CVE-2018-19966                 Xen 4.8 and 4.10 shim
       XSA-279 	CVE-2018-19965                 Xen 4.8 and 4.10 shim
       XSA-275 	CVE-2018-19961 CVE-2018-19962  Xen 4.8 and 4.10 shim
       XSA-278 	CVE-2018-18883                 Xen 4.10 shim only
  * For completeness, the following fixes are not applicable:
       XSA-274 	CVE-2018-14678        Bug is in Linux
       XSA-270 	CVE-2018-15471        Bug is in Linux
       XSA-271 	CVE-2018-14007        Bug is in XAPI (not in Debian)
       XSA-277 	CVE-2018-19964        Bug not in either 4.8 or 4.10
       XSA-276 	CVE-2018-19963        Bug not in either 4.8 or 4.10
  * Added CVEs to previous changelog entries:
       4.8.4+xsa273+shim4.10.1+xsa273-1+deb9u10
       4.8.3+xsa267+shim4.10.1+xsa267-1+deb9u9

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 11 Jan 2019 18:01:30 +0000
